vmail-stack/bin/vmail-mboxes-del.sh
Matthew Saunders Brown 9b5c51bcc9 user permissions checks
2021-03-19 11:58:35 -07:00

96 lines
2.8 KiB
Bash
Executable File

#!/bin/bash
#
# vmail-stack
# https://git.stack-source.com/msb/vmail-stack
# MIT License Copyright (c) 2021 Matthew Saunders Brown
# load config
source /usr/local/etc/vmail.conf || echo "ERROR: Either you do not have vmail user permissions or the config file is missing." && exit
help()
{
thisfilename=$(basename -- "$0")
echo "$thisfilename"
echo "Delete email account."
echo ""
echo "usage: $thisfilename fullemail"
echo ""
echo " -f Force - don't prompt for confirmation."
echo " -h Print this help."
echo ""
echo " Enter account to delete in full email address format."
exit
}
# check for and set email address info
if [ -n "$1" ]; then
if [ $1 == "-h" ]; then
help
elif [[ ! $1 =~ ^- ]] ; then
email=$1
shift
if [[ $email =~ "@" ]] ; then
mbox=${email%@*}
domain=${email##*@}
if ! vmail::validate_domain $domain; then
echo "ERROR: $domain is not a valid domain name."
exit 1
fi
else
echo "ERROR: $email is not a valid email address."
help
fi
fi
fi
# set any options that were passed
while getopts "fh" opt; do
case "${opt}" in
f )
force=true
;;
h )
help
exit;;
\? )
echo "Invalid option: $OPTARG" 1>&2
exit;;
esac
done
# build query
dbcmd="mysql --defaults-extra-file=$MYSQL_CONNECTION_INFO_FILE"
dbcmdopts="-s -r -N -e"
# get email address id which also works to confirm address exists
dbquery="SELECT vm_mboxes.id FROM vm_mboxes, vm_domains WHERE vm_mboxes.mbox='$mbox' AND vm_mboxes.domain_id=vm_domains.id AND vm_domains.domain='$domain'"
mboxes_id=`$dbcmd $dbcmdopts "$dbquery"`
if [ -z "$mboxes_id" ]; then
echo "ERROR: Email address $email does not exist."
exit 1
elif [ "$mboxes_id" -gt '0' ]; then
if [ -n "$force" ] || vmail::yesno "Delete $email now?"; then
# this should be sufficient for vm_* tables due to ON DELETE CASCADE foreign key references
dbquery="DELETE FROM vm_mboxes WHERE vm_mboxes.id='$mboxes_id';"
eval $dbcmd $dbcmdopts "\"$dbquery\""
dbquery="DELETE FROM sa_userpref WHERE username='$email';"
eval $dbcmd $dbcmdopts "\"$dbquery\""
dbquery="DELETE FROM vm_greylisting WHERE recipient='$email';"
eval $dbcmd $dbcmdopts "\"$dbquery\""
dbquery="DELETE FROM vm_greylisting WHERE recipient LIKE '$mbox+%@$domain';"
eval $dbcmd $dbcmdopts "\"$dbquery\""
# this should be sufficient for rc due to ON DELETE CASCADE foreign key references
dbquery="DELETE FROM rc_users WHERE username='$email';"
eval $dbcmd $dbcmdopts "\"$dbquery\""
if [ -d "$VMAIL_DIR/$domain/$mbox" ]; then
rm -r $VMAIL_DIR/$domain/$mbox
fi
echo "SUCCESS: $email removed from system."
exit 0
fi
else
echo "ERROR: System error querying vmail database"
exit 1
fi